''   SD boot utility
'' ------------------
'' (c)2012 Andy Schenk, Insonix.ch

con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  sd_DO  = 8    '<-- your SD pins
  sd_CLK = 9
  sd_DI  = 10
  sd_CS  = 11

var
 long  startsect
 byte  sectbuf[512]
     
obj
 term : "FullDuplexSerial"
 sd   : "fsrw26b"
 
pub main  | err, k
 term.start(31,30,0,115200)
 repeat
   term.str(string(1,"press a key",13))
 until term.rxcheck => 0

 term.str(string("try to mount SD card..",13))
 err := \sd.mount_explicit(sd_DO,sd_CLK,sd_DI,sd_CS)
 if err < 0
   term.str(string("mount error "))
   term.dec(err)
 else
   term.str(string("SD mounted!",13))

 repeat
   term.str(string(13,"Write the boot file? (y/n)"))
   if term.rx == "y"
     err := \sd.popen(string("boot.txt"),"w")
     \sd.pwrite(@text,strsize(@text)+1)
     \sd.pclose
     term.str(string(13,"file written!"))

   term.str(string(13,"Write boot signature? (y/n)"))
   if term.rx == "y"
     err := \sd.popen(string("boot.txt"),"r")
     ifnot err
       startsect := sd.getStartSector
       sd.pclose
       term.str(string(13,"boot file at sector: "))
       term.dec(startsect)
       \sd.readsector(0,@sectbuf)    'read sector 0
       long[@sectbuf+400] := long[@signatur]
       long[@sectbuf+404] := startsect
       \sd.writesector(0,@sectbuf)   'write sector 0 with modifications
       term.str(string(13,"boot signature written!"))
       quit
     else
       term.str(string(13,"no boot file found!"))

   term.str(string(13,"Remove boot signature? (y/n)"))
   if term.rx == "y"
       \sd.readsector(0,@sectbuf)    'read sector 0
       long[@sectbuf+400] := 0
       \sd.writesector(0,@sectbuf)   'write sector 0 with modifications
       term.str(string(13,"boot signature removed!"))
       quit
       
 term.str(string(13,"all done - by!"))
 sd.unmount
       
DAT
         long
signatur byte "BOOT"

text  byte "P2BOOT",13
      byte "Propeller 2 would load this file from SD-",13
      byte "card. If you see this text the boot file",13
      byte "was found and loaded.",13,0
        